#ifdef BROGUE_TCOD                                      
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <SDL2/SDL.h>
#include "noteye.h"
#include "noteye-curses.h"
#include "platform.h"

static struct bufferCell {
	int fore, back;
	int glyph, block, ms, dirty;
} buffer_cells[COLS * ROWS];

static int ms_passed = 0; // milliseconds since last refresh

static struct glyphInfo {
	int isWall;
} glyphTable[256] = {{0}};

#define BUFFER(x, y) (buffer_cells[(x) + (y) * COLS])

int charsmapping[] = {
  0xe1, WALL_CHAR,
  0xe2, FLOOR_CHAR,
  0xe3, DOOR_CHAR,
  0xe4, OPEN_DOOR_CHAR,
  0xe5, WALL_CHAR,
  0xe6, WALL_CHAR,
  0xe7, WALL_CHAR,
  0xe8, WALL_CHAR,
  0xe9, WALL_CHAR,
  0xea, WALL_CHAR,
  0xd0, LEVER_CHAR,
  0xd1, LEVER_PULLED_CHAR,
  0xeb, STATUE_CHAR,
  0xec, ALTAR_CHAR,
  0xed, GEM_CHAR,
  0xef, ALTAR_CHAR,
  0xF0, WALL_CHAR,
  0xF1, ALTAR_CHAR,
  0xF2, ALTAR_CHAR,
  0xF3, ALTAR_CHAR,
  0xF4, ALTAR_CHAR,
  0xF5, ALTAR_CHAR,
  0xF6, CHASM_CHAR,
  0xCD, TRAP_CHAR,
  0xF7, CHASM_CHAR,
  0xCB, DEWAR_CHAR,
  0xF8, MUD_CHAR,
  0xF9, ASH_CHAR,
  0xFA, BRIDGE_CHAR,
  0xF9, FLOOR_CHAR,
  0xFB, ASH_CHAR,
  0xFC, BONES_CHAR,
  0xFD, BONES_CHAR,
  0xFE, BONES_CHAR,
  0   , ASH_CHAR,
  ']' , WEB_CHAR,
  '1' , CHAIN_TOP_LEFT,
  '2' , CHAIN_BOTTOM_RIGHT,
  '3' , CHAIN_TOP_RIGHT,
  '4' , CHAIN_BOTTOM_LEFT,
  '5' , CHAIN_TOP,
  '6' , CHAIN_BOTTOM,
  '7' , CHAIN_LEFT,
  '8' , CHAIN_RIGHT,
  0xde, FOLIAGE_CHAR,
  0xd3, GOLD_CHAR,
  0xDC, ALTAR_CHAR,
  0xDD, ALTAR_CHAR,
  0xCA, 'Y',
  0XCC, 'M',
  0
  };

static void init_glyphTable() {
	int wallsProper[] = {0x23, 0x39, 0xe1, 0x00};
	int wallGlyphs[] = {0x3c, 0x3d, 0xb1, 0xc0, 0xc1, 0xe5, 0xe9, 0xea, 0x00};

	int *glyph;

	glyph = wallGlyphs;
	while (*glyph) glyphTable[*(glyph++)].isWall = 1;

	glyph = wallsProper;
	while (*glyph) glyphTable[*(glyph++)].isWall = 2;
}

#define DBASE (512*6)

extern playerCharacter rogue;
extern creature player;

struct mouseState {int x, y, lmb, rmb;};

#define MOUSEQUEUESIZE 1024

rogueEvent *evqueue[MOUSEQUEUESIZE];
int eqb, eqe;

int last = 999;

/* void brogue_profile(const char *c) {
  int t = SDL_GetTicks();
  printf("%5d %s\n", t-last, c);
  last = t;
  }

static int lh_brogue_profile(lua_State *L) {
  checkArg(L, 1, "profile");
  const char *c = luaStr(1);
  brogue_profile(c);
  } */

//CAT
//*********** music loops, sound effect and background music
extern boolean cat_loading;

Mix_Music *music[10];
Mix_Chunk *sound[100];

int currentLoop= -1;
int currentMusic= -1;

int loopVolume= 0;
int battleVolume= 0;
int resumeFadeInCounter= -1;
boolean battleOn= false;
int fadeIn= 0;
void initAudio()
{
   SDL_Init(SDL_INIT_AUDIO);
   Mix_OpenAudio(22050, MIX_DEFAULT_FORMAT, 2, 4096);

//*** background music
	music[0] = Mix_LoadMUS("./audio/bkg_intro.wav");
	music[2] = Mix_LoadMUS("./audio/bkg_level1.wav");
	music[3] = Mix_LoadMUS("./audio/bkg_level2.wav");
	music[4] = Mix_LoadMUS("./audio/bkg_ending.wav");
    music[5] = Mix_LoadMUS("./audio/bkg_finale.wav");

    music[9] = Mix_LoadMUS("./audio/bkg_hallucinate.wav");

//*** sound effects
	sound[0] = Mix_LoadWAV("./audio/bkg_battle.wav");
	sound[1] = Mix_LoadWAV("./audio/act_notOverYet.wav");
    sound[2] = Mix_LoadWAV("./audio/int_laughter.wav");

    sound[17] = Mix_LoadWAV("./audio/rea_shriek.wav");

	sound[11] = Mix_LoadWAV("./audio/step_ground.wav");
	sound[12] = Mix_LoadWAV("./audio/step_water.wav");
    sound[13] = Mix_LoadWAV("./audio/step_swim.wav");
    sound[14] = Mix_LoadWAV("./audio/step_grass.wav");
    sound[15] = Mix_LoadWAV("./audio/step_bridge.wav");
    sound[16] = Mix_LoadWAV("./audio/step_mud.wav");
    sound[33] = Mix_LoadWAV("./audio/step_air.wav");


/*
	sound[71] = Mix_LoadWAV("./audio/step_ground1.wav");
	sound[72] = Mix_LoadWAV("./audio/step_ground2.wav");
	sound[73] = Mix_LoadWAV("./audio/step_ground3.wav");
	sound[74] = Mix_LoadWAV("./audio/step_grass1.wav");
	sound[75] = Mix_LoadWAV("./audio/step_grass2.wav");
*/

    sound[18] = Mix_LoadWAV("./audio/rea_find.wav");
    sound[19] = Mix_LoadWAV("./audio/rea_discover.wav");

    sound[4] = Mix_LoadWAV("./audio/act_pickup.wav");
    sound[40] = Mix_LoadWAV("./audio/act_lunge.wav");
    sound[43] = Mix_LoadWAV("./audio/act_open.wav");
    sound[44] = Mix_LoadWAV("./audio/act_attack.wav");
    sound[46] = Mix_LoadWAV("./audio/act_liberate.wav");
    sound[47] = Mix_LoadWAV("./audio/act_throw.wav");
    sound[48] = Mix_LoadWAV("./audio/act_drop.wav");
    sound[49] = Mix_LoadWAV("./audio/act_drink.wav");
    sound[50] = Mix_LoadWAV("./audio/act_eat.wav");
    sound[51] = Mix_LoadWAV("./audio/act_charm.wav");
    sound[52] = Mix_LoadWAV("./audio/act_unlock.wav");
    sound[53] = Mix_LoadWAV("./audio/act_close.wav");
    sound[56] = Mix_LoadWAV("./audio/act_vomit.wav");
    sound[57] = Mix_LoadWAV("./audio/act_equip.wav");
    sound[58] = Mix_LoadWAV("./audio/act_unequip.wav");
    sound[59] = Mix_LoadWAV("./audio/act_search.wav");

    sound[54] = Mix_LoadWAV("./audio/mon_attack.wav");
    sound[55] = Mix_LoadWAV("./audio/mon_miss.wav");
    sound[96] = Mix_LoadWAV("./audio/mon_die.wav");
    sound[6] = Mix_LoadWAV("./audio/mon_pain.wav");
    sound[8] = Mix_LoadWAV("./audio/mon_alert.wav");
    sound[9] = Mix_LoadWAV("./audio/mon_purr.wav");
    sound[10] = Mix_LoadWAV("./audio/mon_plunge.wav");
    sound[68] = Mix_LoadWAV("./audio/mon_wait.wav");
    sound[69] = Mix_LoadWAV("./audio/mon_go.wav");

    sound[3] = Mix_LoadWAV("./audio/rea_error.wav");
    sound[5] = Mix_LoadWAV("./audio/rea_pain.wav");
    sound[7] = Mix_LoadWAV("./audio/rea_click.wav");
    sound[45] = Mix_LoadWAV("./audio/rea_miss.wav");

    sound[79] = Mix_LoadWAV("./audio/rea_spark.wav");

    sound[20] = Mix_LoadWAV("./audio/rea_shatter.wav");
    sound[21] = Mix_LoadWAV("./audio/rea_ignite.wav");
    sound[22] = Mix_LoadWAV("./audio/rea_burst.wav");
    sound[23] = Mix_LoadWAV("./audio/rea_gold.wav");
    sound[24] = Mix_LoadWAV("./audio/rea_die.wav");
    sound[25] = Mix_LoadWAV("./audio/rea_explode.wav");
    sound[26] = Mix_LoadWAV("./audio/rea_stuck.wav");
    sound[27] = Mix_LoadWAV("./audio/rea_machine.wav");
    sound[28] = Mix_LoadWAV("./audio/rea_heart.wav");
    sound[29] = Mix_LoadWAV("./audio/rea_foliage.wav");
    sound[35] = Mix_LoadWAV("./audio/rea_vent.wav");
    sound[36] = Mix_LoadWAV("./audio/rea_crumble.wav");
    sound[37] = Mix_LoadWAV("./audio/rea_puff.wav");
    sound[38] = Mix_LoadWAV("./audio/rea_cursed.wav");
    sound[39] = Mix_LoadWAV("./audio/rea_fall.wav");

    sound[30] = Mix_LoadWAV("./audio/int_stairs.wav");
    sound[31] = Mix_LoadWAV("./audio/int_over.wav");
    sound[32] = Mix_LoadWAV("./audio/int_over2.wav");

    sound[60] = Mix_LoadWAV("./audio/usr_click.wav");
    sound[61] = Mix_LoadWAV("./audio/usr_open.wav");
    sound[62] = Mix_LoadWAV("./audio/usr_close.wav");
    sound[63] = Mix_LoadWAV("./audio/usr_button.wav");
    sound[64] = Mix_LoadWAV("./audio/usr_button2.wav");

    sound[70] = Mix_LoadWAV("./audio/pot_life.wav");

    sound[81] = Mix_LoadWAV("./audio/env_growl1.wav");
    sound[82] = Mix_LoadWAV("./audio/env_growl2.wav");
    sound[83] = Mix_LoadWAV("./audio/env_growl3.wav");
    sound[84] = Mix_LoadWAV("./audio/env_growl4.wav");
    sound[85] = Mix_LoadWAV("./audio/env_growl5.wav");


    sound[80] = Mix_LoadWAV("./audio/env_brimstone.wav");
    sound[86] = Mix_LoadWAV("./audio/env_chasm.wav");
    sound[87] = Mix_LoadWAV("./audio/env_lava.wav");
    sound[88] = Mix_LoadWAV("./audio/env_fire.wav");
    sound[89] = Mix_LoadWAV("./audio/env_water.wav");
    sound[99] = Mix_LoadWAV("./audio/env_mud.wav");
    sound[97] = Mix_LoadWAV("./audio/env_ambient.wav");


    sound[90] = Mix_LoadWAV("./audio/act_wand.wav");
    sound[91] = Mix_LoadWAV("./audio/act_read1.wav");
    sound[92] = Mix_LoadWAV("./audio/act_read2.wav");
    sound[93] = Mix_LoadWAV("./audio/act_read3.wav");
    sound[94] = Mix_LoadWAV("./audio/act_read4.wav");
    sound[95] = Mix_LoadWAV("./audio/act_read5.wav");

//Mix_FreeMusic(music);
//Mix_PlayingMusic() == 0
}


void playMusic(int ID)
{
    if(cat_loading)
        return;

    if(currentMusic != ID)
    {
        currentMusic= ID;
        Mix_VolumeMusic(120);
        Mix_PlayMusic(music[ID], -1);
    }
}

void stopMusic()
{
    if(cat_loading)
        return;

    Mix_HaltMusic();
    currentMusic= -1;
}


static int soundLoop= 0;
void playSound(int ID)
{
    if(cat_loading)
        return;

    Mix_Volume(7, loopVolume);
    Mix_Volume(6, battleVolume);


    Mix_Volume(soundLoop, 120);
    Mix_PlayChannel(soundLoop, sound[ID], 0);

    soundLoop++;
    if(soundLoop > 3)
        soundLoop= 0;
}

void playSoundNoOverlap(int ID)
{
    if(cat_loading)
        return;

    Mix_Volume(4, 120);
    Mix_Volume(7, loopVolume);
    Mix_Volume(6, battleVolume);
    Mix_PlayChannel(4, sound[ID], 0);
}


void playSoundNoOverlap_steps(int ID)
{
    if(cat_loading)
        return;

    Mix_Volume(5, 120);
    Mix_Volume(7, loopVolume);
    Mix_Volume(6, battleVolume);
    Mix_PlayChannel(5, sound[ID], 0);
}

void playLoop(int ID, int loopVol)
{
    if(cat_loading)
        return;

    loopVolume= loopVol;
    Mix_Volume(7, loopVolume);

    if(currentLoop != ID)
    {
        currentLoop= ID;
        Mix_FadeInChannel(7, sound[ID], -1, 1500);
//        Mix_PlayChannel(7, sound[ID], -1);
    }

}

void stopLoop()
{
    loopVolume= 0;
    currentLoop= -1;
    Mix_FadeOutChannel(7, 2000);

//  Mix_HaltChannel(7);
}


void playBattle(boolean start)
{
    if(cat_loading)
        return;

    fadeIn= 0;

    if(start)
    {
        battleVolume= 120;
        Mix_Volume(6, battleVolume);

        if(!battleOn)
        {
            Mix_PlayChannel(6, sound[0], -1);
            Mix_PauseMusic();
        }

        battleOn= true;
    }
    else
    if(battleOn && !start)
    {
        fadeIn= 23;
        battleOn= false;

        Mix_VolumeMusic(10);
        Mix_ResumeMusic();

        Mix_FadeOutChannel(6, 3000);

//        Mix_HaltChannel(6);
    }
}


void fadeBattle(int dVolume)
{
	battleVolume+= dVolume;
	if(battleVolume > 120)
		battleVolume= 120;
	else
	if(battleVolume < 0)
		battleVolume= 0;

    Mix_Volume(6, battleVolume);
}

static int lh_brogue_stripfont(lua_State *L) {
  checkArg(L, 1, "stripfont");
  int i = luaInt(1);
  if(i < 256) return noteye_retInt(L, i);
  int *p = charsmapping;
  while(p[0]) { 
    if(*p == (i&255)) return noteye_retInt(L, p[1]);
    p += 2;
    }
  return noteye_retInt(L, i & 255);
  }

static int lh_brogue_getdata(lua_State *L) {
  noteye_table_new(L);

  if(noteyeData.ingame)
    noteye_table_setInt(L, "ingame", 1);

  if(noteyeData.inintro)
    noteye_table_setInt(L, "inintro", 1);

  noteye_table_setInt(L, "player_x", player.xLoc);
  noteye_table_setInt(L, "player_y", player.yLoc);

  noteye_table_setInt(L, "inv_minx", noteyeData.inv.minx);
  noteye_table_setInt(L, "inv_miny", noteyeData.inv.miny);
  noteye_table_setInt(L, "inv_maxx", noteyeData.inv.maxx);
  noteye_table_setInt(L, "inv_maxy", noteyeData.inv.maxy);

  noteye_table_setInt(L, "textbox_minx", noteyeData.text.minx);
  noteye_table_setInt(L, "textbox_miny", noteyeData.text.miny);
  noteye_table_setInt(L, "textbox_maxx", noteyeData.text.maxx);
  noteye_table_setInt(L, "textbox_maxy", noteyeData.text.maxy);
  return 1;
  }

static int lh_brogue_sendmouse(lua_State *L) {
  checkArg(L, 4, "sendmouse");
  int x = luaInt(1);
  int y = luaInt(2);
  int t = luaInt(3);
  int b = luaInt(4);

  rogueEvent ev;
  ev.eventType = 0; ev.controlKey = false; ev.shiftKey = false;
  ev.param1 = x; ev.param2=y;

  if(t == evMouseMotion) {
    ev.eventType = MOUSE_ENTERED_CELL;
    }
  else if(t == evMouseDown && b == 1) {
    ev.eventType = MOUSE_DOWN;
    }
  else if(t == evMouseUp && b == 1) {
    ev.eventType = MOUSE_UP;
    }
  else if(t == evMouseDown && b == 3) {
    ev.eventType = RIGHT_MOUSE_DOWN;
    }
  else if(t == evMouseUp && b == 3) {
    ev.eventType = RIGHT_MOUSE_UP;
    }
  else return 0;
  evqueue[eqe] = malloc(sizeof(rogueEvent));
  evqueue[eqe][0] = ev;
  eqe++; eqe %= MOUSEQUEUESIZE;
   
  return 0;
  }

static void gameLoop()
{
        init_glyphTable();
	/* if (SDL_Init(SDL_INIT_VIDEO)) {
		printf ("Could not start SDL.\n");
		return;
	} */

	// loadFont(true);

        noteye_init();
//      noteye_globalstr("noteyedir", "noteye/");

        noteye_globalint("brogue_sizey", ROWS);
        noteye_globalint("brogue_sizex", COLS);
        noteye_globalfun("brogue_sendmouse", lh_brogue_sendmouse);
        noteye_globalfun("brogue_getdata", lh_brogue_getdata);
        noteye_globalfun("brogue_stripfont", lh_brogue_stripfont);
//      noteye_globalfun("brogue_profile", lh_brogue_profile);

  noteye_run("games/brogue.noe", 1);

  initAudio();
    playMusic(0);
	rogueMain();

  noteye_finishinternal(1);
  // close the UI thread
  noteye_uifinish();
  // finish NotEye (this also exits the process)
  noteye_halt();

	// TCOD_console_delete(NULL);
}

int nextblockat = 0, sync_anim_block = 0, animation_enabled = 1, dancing_colors_enabled = 1;

static void noteye_plotChar(uchar inputChar,
                          short xLoc, short yLoc,
                          short foreRed, short foreGreen, short foreBlue,
                          short backRed, short backGreen, short backBlue) {

        int block = 2; 

	if (inputChar < 0) {
	        inputChar = -inputChar;
		//block = rand() % 3 < 2 ? 0 : 1;
		block = sync_anim_block;
	}

        int fore = (((uint8) foreRed * 255 / 100) << 16) +
                   (((uint8) foreGreen * 255 / 100) << 8) + 
                   ((uint8) foreBlue * 255 / 100);

        int back = (((uint8) backRed * 255 / 100) << 16) +
                   (((uint8) backGreen * 255 / 100) << 8) + 
                   ((uint8) backBlue * 255 / 100);

	if (inputChar == STATUE_CHAR) {
		inputChar = 223;
	} else if (inputChar > 255) {
		switch (inputChar) {
#ifdef USE_UNICODE
			case FLOOR_CHAR: inputChar = 128 + 0; break;
			case CHASM_CHAR: inputChar = 128 + 1; break;
			case TRAP_CHAR: inputChar = 128 + 2; break;
			case FIRE_CHAR: inputChar = 128 + 3; break;
			case FOLIAGE_CHAR: inputChar = 128 + 4; break;
			case AMULET_CHAR: inputChar = 128 + 5; break;
			case SCROLL_CHAR: inputChar = 128 + 6; break;
			case RING_CHAR: inputChar = 128 + 7; break;
			case WEAPON_CHAR: inputChar = 128 + 8; break;
			case GEM_CHAR: inputChar = 128 + 9; break;
			case TOTEM_CHAR: inputChar = 128 + 10; break;
			case BAD_MAGIC_CHAR: inputChar = 128 + 12; break;
			case GOOD_MAGIC_CHAR: inputChar = 128 + 13; break;

			case DOWN_ARROW_CHAR: inputChar = 144 + 1; break;
			case LEFT_ARROW_CHAR: inputChar = 144 + 2; break;
			case RIGHT_ARROW_CHAR: inputChar = 144 + 3; break;
			case UP_TRIANGLE_CHAR: inputChar = 144 + 4; break;
			case DOWN_TRIANGLE_CHAR: inputChar = 144 + 5; break;
			case OMEGA_CHAR: inputChar = 144 + 6; break;
			case THETA_CHAR: inputChar = 144 + 7; break;
			case LAMDA_CHAR: inputChar = 144 + 8; break;
			case KOPPA_CHAR: inputChar = 144 + 9; break; // is this right?
			case CHARM_CHAR: inputChar = 144 + 9; break;
			case LOZENGE_CHAR: inputChar = 144 + 10; break;
			case CROSS_PRODUCT_CHAR: inputChar = 144 + 11; break;
#endif
			default: inputChar = '?'; break;
		}
	}

	struct bufferCell *cell = &BUFFER(xLoc, yLoc);
	cell->glyph = inputChar;
	//cell->block = block;
	cell->block = block;
    	cell->fore = fore;
	cell->back = back;
    //cell->ms = (block == 2) ? 0 : (cell->block ? 600 : 500);
	cell->dirty = 1;
}


static void noteye_refresh_oryx()
{
        int t = SDL_GetTicks();
        if(t >= nextblockat || t < nextblockat - 6000) {
          nextblockat = t + 900;
          sync_anim_block = 1 - sync_anim_block;
          }

	int x, y;
	for (y = 0; y < ROWS; y++) {
		for (x = 0; x < COLS; x++) {
			struct bufferCell *cell = &BUFFER(x, y);

			if (cell->block != 2) {
				if (true) {
					//cell->ms -= ms_passed;
					//if (cell->ms <= 0) {
						//cell->dirty = 1;
						//cell->block = 1 - cell->block; // toggle between 0 and 1
						//cell->ms = cell->block ? 600 : 500;
					//}

					if (cell->block != sync_anim_block) {
						cell->block = sync_anim_block;
						cell->dirty = 1;
					}
				}
				if (y < ROWS && glyphTable[cell->glyph].isWall == 2) {
					if (glyphTable[(cell + COLS)->glyph].isWall != 0) {
						cell->glyph = 0xb1; // vertical wall
						cell->dirty = 1;
					}
				}
			}
			if (cell->dirty) {

        noteye_move(y, x); 
        setTextAttr32(cell->fore & 0xFFCFCFC, cell->back & 0xFF8F8F8);
        int cb = (cell->block +1) % 3;
        noteye_addchx(cell->glyph + (cb << 8));
				cell->dirty = 0;
			}
		}
	}

	ms_passed = 0;
	noteye_refresh();
}


static void getModifiers(rogueEvent *returnEvent) {
  int num;
  const Uint8 *keystate = SDL_GetKeyboardState(&num);

  returnEvent->controlKey = keystate[SDL_SCANCODE_LCTRL] || keystate[SDL_SCANCODE_RCTRL];
  returnEvent->shiftKey = keystate[SDL_SCANCODE_LSHIFT] || keystate[SDL_SCANCODE_RSHIFT];
  }

int savedkey = -1;

int pauseends = -1;

static boolean noteye_pauseForMilliseconds(short milliseconds)
{ 
  noteye_halfdelayms(0);
  int t = SDL_GetTicks();
  if(pauseends == -1) pauseends = t + milliseconds;
  else pauseends = pauseends + milliseconds;
  while(SDL_GetTicks() < pauseends) {
    noteye_refresh_oryx();
    savedkey = noteye_getch();
    if(savedkey != -1 || eqb != eqe) return true;
    }
  return false;
}


#define PAUSE_BETWEEN_EVENT_POLLING		36//17

static void noteye_nextKeyOrMouseEvent(rogueEvent *returnEvent, boolean textInput, boolean colorsDance)
{
  //brogue_profile("nextkey");
  noteye_halfdelayms(0);
  pauseends = -1;

  while(true) {
    if(eqb != eqe) {
      *returnEvent = *evqueue[eqb];
      eqb++; eqb %= MOUSEQUEUESIZE;
      if(returnEvent->eventType == MOUSE_ENTERED_CELL) {
        int c = eqb;
        bool ignore = false;
        for(; c != eqe; c++, c %= MOUSEQUEUESIZE) 
          if(evqueue[c]->eventType == MOUSE_ENTERED_CELL)
            ignore = true;
        if(ignore) continue;
        }
      getModifiers(returnEvent);
      //brogue_profile("received mouse");
      return;
      }
    int ch;
    //brogue_profile("getch");
    if(savedkey != -1) { ch = savedkey; savedkey = -1; }
    else ch = noteye_getch();
    if(ch == -1) {  
     if (colorsDance) {
        shuffleTerrainColors(3, true);
        commitDraws();
        }
      //brogue_profile("refresh");
      noteye_refresh_oryx();
      }
    else {
      returnEvent->eventType = KEYSTROKE;
      getModifiers(returnEvent);

      if(ch == DBASE) ch = NUMPAD_6;
      if(ch == DBASE+1) ch = NUMPAD_9;
      if(ch == DBASE+2) ch = NUMPAD_8;
      if(ch == DBASE+3) ch = NUMPAD_7;
      if(ch == DBASE+4) ch = NUMPAD_4;
      if(ch == DBASE+5) ch = NUMPAD_1;
      if(ch == DBASE+6) ch = NUMPAD_2;
      if(ch == DBASE+7) ch = NUMPAD_3;
      if(ch == 8) ch = DELETE_KEY;
      returnEvent->param1 = ch;
      returnEvent->param2 = ch;
      //brogue_profile("key received");
      return;
      }
    }



/*		
		if (!(serverMode || (SDL_GetAppState() & SDL_APPACTIVE))) {
			TCOD_sys_sleep_milli(100);
		} else {
			if (colorsDance) {
				shuffleTerrainColors(3, true);
				commitDraws();
			}
			TCOD_console_flush();
		} 


		waitTime = PAUSE_BETWEEN_EVENT_POLLING + theTime - TCOD_sys_elapsed_milli();
		
		if (waitTime > 0 && waitTime <= PAUSE_BETWEEN_EVENT_POLLING) {
			TCOD_sys_sleep_milli(waitTime);
		}
	} */
}



// tcodkeys is derived from console_types.h
char *tcodkeys[] = {
	"NONE",
	"ESCAPE",
	"BACKSPACE",
	"TAB",
	"ENTER",
	"SHIFT",
	"CONTROL",
	"ALT",
	"PAUSE",
	"CAPSLOCK",
	"PAGEUP",
	"PAGEDOWN",
	"END",
	"HOME",
	"UP",
	"LEFT",
	"RIGHT",
	"DOWN",
	"PRINTSCREEN",
	"INSERT",
	"DELETE",
	"LWIN",
	"RWIN",
	"APPS",
	"0",
	"1",
	"2",
	"3",
	"4",
	"5",
	"6",
	"7",
	"8",
	"9",
	"KP0",
	"KP1",
	"KP2",
	"KP3",
	"KP4",
	"KP5",
	"KP6",
	"KP7",
	"KP8",
	"KP9",
	"KPADD",
	"KPSUB",
	"KPDIV",
	"KPMUL",
	"KPDEC",
	"KPENTER",
	"F1",
	"F2",
	"F3",
	"F4",
	"F5",
	"F6",
	"F7",
	"F8",
	"F9",
	"F10",
	"F11",
	"F12",
	"NUMLOCK",
	"SCROLLLOCK",
	"SPACE",
	"CHAR",
	NULL
};

static void noteye_remap(const char *input_name, const char *output_name) { 
  printf("remapping not available in NotEye!\n");
  }

static boolean modifier_held(int modifier) {
	rogueEvent tempEvent;

	getModifiers(&tempEvent);
	if (modifier == 0) return tempEvent.shiftKey;
	if (modifier == 1) return tempEvent.controlKey;

	return 0;
}

struct brogueConsole noteyeConsole = {
	gameLoop,
	noteye_pauseForMilliseconds,
	noteye_nextKeyOrMouseEvent,
	noteye_plotChar,
	noteye_remap,
	modifier_held
};

#endif

